{=======================================================================================================================

  Project Source Sort

      .

========================================================================================================================

  :

  13.04.2015 [*]      .
  11.04.2015 [*]   .
  04.04.2012 [+]   'in'.
  16.03.2012 [+]  .
  16.03.2012 [!]  .

========================================================================================================================
  Copyright 20122015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: main.pas,v 1.2 2015/04/28 15:34:11 tsk Exp $
=======================================================================================================================}
unit main;

interface

uses  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls,
      Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, PropFilerEh, PropStorageEh, Math,
      // Comming:
      CommingVersionInfo;

type
  TMainFM = class(TForm)
    cbFile: TComboBox;
    btSort: TBitBtn;
    btSave: TBitBtn;
    btOpen: TBitBtn;
    mmProject: TMemo;
    dgOpen: TOpenDialog;
    regMain: TRegPropStorageManEh;
    propMain: TPropStorageEh;
    laVersion: TLabel;
    procedure btOpenClick(Sender: TObject);
    procedure btSortClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private { Private declarations }
  public  { Public declarations }
  end;

var
  MainFM: TMainFM;

implementation

{$R *.dfm}
//======================================================================================================================
{ TMainFM }
//======================================================================================================================
procedure TMainFM.FormCreate(Sender: TObject);
begin
  laVersion.Caption := GetVersionInfo( True );
end;
//======================================================================================================================
procedure TMainFM.btOpenClick(Sender: TObject);
  var ProjectFile: String;
      Dialog: Boolean;
begin
  Dialog := False;
  if ( cbFile.Text = EmptyStr )
    then Dialog := True
    else if FileExists( cbFile.Text ) then ProjectFile := cbFile.Text;
    if Dialog and dgOpen.Execute then begin
        ProjectFile := dgOpen.FileName;
        cbFile.Text := ProjectFile;
      end;
  mmProject.Lines.LoadFromFile( ProjectFile );
  btSort.Enabled := ( mmProject.Lines.Count > 0 )
end;
//======================================================================================================================
procedure TMainFM.btSortClick(Sender: TObject);
  var i, p, pIn, lBeg, lEnd, cBASE, cCust: Integer;
      buff: String;
      ch: Boolean;
  function SortValue( Ln: String): String;
    var b, e: Integer;
  begin
    b := Pos( '''', Ln );
    e := Pos( '.pas', Ln );
    Result := Copy( Ln, b + 1, e - b - 1 );
  end;
  function Alignment( Ln: String; pi: Integer): String;
    var p: Integer;
        md, fl: String;
  begin
    p := Pos( ' in ', Ln );
    md := Copy( Ln, 1, p - 1);
    fl := Copy( Ln, p + 4, MaxInt );
    Result := Format('%-' + IntToStr(pi) + 'sin %s', [ md, fl ]);
  end;
begin
  lBeg := 0; lEnd := 0; cBASE := 0; cCust := 0;
  btOpen.Enabled := False;
  //   units
  for i := 0 to mmProject.Lines.Count - 1 do begin
    if ( lBeg = 0 ) and ( Pos( ' in ', mmProject.Lines[i]) > 0 ) then lBeg := i;
    if ( lEnd = 0 ) and ( Pos( ' in ', mmProject.Lines[i]) > 0 ) and ( Pos( ';', mmProject.Lines[i]) > 0 ) then lEnd := i;
  end;
  // :
  pIn := 0;
  for i := lBeg to lEnd do begin
    //      IN;
    mmProject.Lines[i] := Copy( mmProject.Lines[i], 1, Length( mmProject.Lines[i] ) - 1);
    p := Pos( ' in ', mmProject.Lines[i] );
    pIn := Max( p, pIn );
    mmProject.Lines[i] := Alignment( mmProject.Lines[i], pIn );
  end;
  repeat
    ch := True;
    for i := lBeg to lEnd - 1 do
      if SortValue( mmProject.Lines[i] ) > SortValue( mmProject.Lines[i+1] ) then begin
        buff := mmProject.Lines[i];
        mmProject.Lines[i] := mmProject.Lines[i+1];
        mmProject.Lines[i+1] := buff;
        ch := False;
      end;
  until ch;
  // :
  for i := lBeg to lEnd do begin
    mmProject.Lines[i] := Alignment( mmProject.Lines[i], pIn );
    if ( Pos( 'BASE', AnsiUpperCase( mmProject.Lines[i])) > 0 ) then Inc( cBASE ) else Inc( cCust );
    // :
    if (i = lEnd)
      then mmProject.Lines[i] := mmProject.Lines[i] + ';'
      else mmProject.Lines[i] := mmProject.Lines[i] + ','
  end;
  buff := Format( '{ Total: %d customer modules, %d base modules }', [ cCust, cBASE ]);
  mmProject.Lines[lEnd + 1] := buff;
  while (Pos( '$R', mmProject.Lines[lEnd + 2]) = 0) do mmProject.Lines.Delete( lEnd + 2 );
  btSave.Enabled := True;
end;
//======================================================================================================================
procedure TMainFM.btSaveClick(Sender: TObject);
begin
  btSort.Enabled := False;
  if cbFile.Items.IndexOf( cbFile.Text ) < 0 then cbFile.Items.Add( cbFile.Text );
  while cbFile.Items.Count > cbFile.DropDownCount do cbFile.Items.Delete(0);
  mmProject.Lines.SaveToFile( cbFile.Text );
  btOpen.Enabled := True;
  btSave.Enabled := False;
end;
//======================================================================================================================
end.
